'use strict';

var UploadAppServices = angular.module('UploadAppServices', ['ngFileUpload']);

UploadAppServices.factory('UploadApp', ['$http', 'Upload', 'CacheApp',
  function ($http, Upload, CacheApp) {

    var urlService = "https://vighapi.vighapp.com/";

    var uploadAppFactory = {};

    uploadAppFactory.UploadNotaFiscal = function (image, nota, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo('uploadNotaFiscal?IdNotaFiscal=' + nota.IdNotaFiscal + '&IdConstrucao=' + nota.IdConstrucao, image,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    }

    uploadAppFactory.UploadImagemConstrucao = function (imagem, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo('uploadImagemConstrucao?IdConstrucao=' + imagem.IdConstrucao + "&IdEtapa=" + imagem.IdEtapa + "&Descricao=" + imagem.Descricao + "&Data=" + imagem.Data, imagem.file,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    }

    uploadAppFactory.UploadImagemAvatar = function (imagem, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo('uploadImagemAvatar?trash=0', imagem,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    }

    uploadAppFactory.uploadCertificadoA1 = (params, callBackProgress, callBackSuccess, callBackError) => {
        uploadAppFactory.UploadGo(`uploadCertificadoA1?IdCliente=${params.IdCliente}&Cnpj=${params.Cnpj}&Senha=${params.Senha}&DataInicio=${params.DataInicio}`, params.File,
            (data) => {
                callBackProgress(data);
            },
            (data) => {
                callBackSuccess(data);
            },
            (err) => {
                callBackError(err);
            }
        );
    }

    uploadAppFactory.getLancamentoFromImage = (imagem, callBackProgress, callBackSuccess, callBackError) => {
        uploadAppFactory.UploadGo('getLancamentoFromImage?trash=0', imagem,
            (data) => {
                callBackProgress(data);
            },
            (data) => {
                callBackSuccess(data);
            },
            (err) => {
                callBackError(err);
            });
    }

    uploadAppFactory.importaComposicao = function (arquivo, IdConstrucao, callBackFunction) {
        //$('#BoxLoadWait').modal('show');
        uploadAppFactory.showLoad();

        var chave = CacheApp.getSessao() ? CacheApp.getSessao().Chave : '';
        var request = $http({
            method: "post",
            url: urlService + 'importaComposicao?IdConstrucao=' + IdConstrucao + '&chave=' + chave,
            data: arquivo
        });

        request.success(
            function (data) {
                //$('#BoxLoadWait').modal('hide');
                uploadAppFactory.hideLoad();
                callBackFunction(data);
            }
        );

    }

    uploadAppFactory.importaOrcamento = function (arquivo, IdConstrucao, callBackFunction) {
        //$('#BoxLoadWait').modal('show');
        uploadAppFactory.showLoad();

        var chave = CacheApp.getSessao() ? CacheApp.getSessao().Chave : '';
        var request = $http({
            method: "post",
            url: urlService + 'importaOrcamento?IdConstrucao=' + IdConstrucao + '&chave=' + chave,
            data: arquivo
        });

        request.success(
            function (data) {
                //$('#BoxLoadWait').modal('hide');
                uploadAppFactory.hideLoad();
                callBackFunction(data);
            }
        );

    }

    uploadAppFactory.setComposicao = function (arquivo, IdConstrucao, callBackFunction) {
        //$('#BoxLoadWait').modal('show');
        uploadAppFactory.showLoad();

        var chave = CacheApp.getSessao() ? CacheApp.getSessao().Chave : '';
        var request = $http({
            method: "post",
            url: urlService + 'setComposicao?IdConstrucao=' + IdConstrucao + '&chave=' + chave,
            data: arquivo
        });

        request.success(
            function (data) {
                //$('#BoxLoadWait').modal('hide');
                uploadAppFactory.hideLoad();
                callBackFunction(data);
            }
        );
    }

    uploadAppFactory.postSolicitacaoListaItens = function (arquivo, callBackFunction) {
        uploadAppFactory.showLoad();

        var chave = CacheApp.getSessao() ? CacheApp.getSessao().Chave : '';
        var request = $http({
            method: "post",
            url: urlService + 'postSolicitacaoListaItens?chave=' + chave,
            data: arquivo
        });

        request.success(
            function (data) {
                uploadAppFactory.hideLoad();
                callBackFunction(data);
            }
        );
    }
    
    uploadAppFactory.setOcorrencia = function (imagem, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo('setOcorrenciaImagem?IdConstrucao=' + imagem.IdConstrucao + "&Descricao=" + imagem.Descricao + "&Data=" + imagem.Data, imagem.file,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    }

    uploadAppFactory.UploadDocumento = function (imagem, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo('uploadDocumento?IdConstrucao=' + imagem.IdConstrucao + "&Descricao=" + imagem.Descricao, imagem.file,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    };

    uploadAppFactory.UploadXmlNotaFiscal = function (xmlFile, callBackProgress, callBackSuccess, callBackError) {
        var urlServ = `UploadXmlNotaFiscal?IdConstrucao=${xmlFile.IdConstrucao}&IdClienteDono=${xmlFile.IdClienteDono}&TipoLancamento=${xmlFile.TipoLancamento}&Fonte=${xmlFile.Fonte}&Categoria=${xmlFile.Categoria}`
        if (xmlFile.IdEtapa)
            urlServ += `&IdEtapa=${xmlFile.IdEtapa}`;
        if (xmlFile.IdComposicao)
            urlServ += `&IdComposicao=${xmlFile.IdComposicao}`;

        uploadAppFactory.UploadGo(urlServ, xmlFile.file,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    };

    uploadAppFactory.UploadPlanilhaOrcamento = function (params, config, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.UploadGo(`uploadPlanilhaOrcamento?IdConstrucao=${params.IdConstrucao}&IdCliente=${params.IdCliente}&Config=${JSON.stringify(config)}`, params.file,
            function (data) {
                callBackProgress(data);
            },
            function (data) {
                callBackSuccess(data);
            },
            function (err) {
                callBackError(err);
            });
    };

    uploadAppFactory.UploadPlanilhaNotaFiscal = (planilha, callBackProgress, callBackSuccess, callBackError) => {
        var urlServ = `UploadPlanilhaNotaFiscal?IdConstrucao=${planilha.IdConstrucao}&IdClienteDono=${planilha.IdClienteDono}`

        uploadAppFactory.UploadGo(urlServ, planilha.file,
            (data) => {
                callBackProgress(data);
            },
            (data) => {
                callBackSuccess(data);
            },
            (err) => {
                callBackError(err);
            });
    };

    uploadAppFactory.UploadGo = function (service, file, callBackProgress, callBackSuccess, callBackError) {
        uploadAppFactory.showLoad();
        var chave = CacheApp.getSessao() ? CacheApp.getSessao().Chave : '';
        Upload.upload({
            url: urlService + service + '&chave=' + chave,
            method: 'POST',
            data: { file: file }
        }).progress(function (event) {
            callBackProgress(((event.loaded / event.total) * 100).toFixed(2));
        }).success(function (data, status, headers, config) {
            uploadAppFactory.hideLoad();
            callBackSuccess(data);
        }).error(function (err) {
            uploadAppFactory.hideLoad();
            callBackError(err);
        });
    }

    uploadAppFactory.showLoad = function() {
        swal({
            title: 'Processando...',
            showConfirmButton: false,
            onOpen: () => {
                swal.showLoading();
            }
        });
    }

    uploadAppFactory.hideLoad = function() {
        swal({
            type: 'success',
            title: 'Processado com sucesso!',
            showConfirmButton: false,
            timer: 1000
        });
    }

    return uploadAppFactory;
  }]);
